package com.sun.corba.se.impl.activation;

import java.util.Iterator;
import java.util.ConcurrentModificationException;
import java.util.HashMap;

public class ProcessMonitorThread extends Thread
{
    private HashMap serverTable;
    private int sleepTime;
    private static ProcessMonitorThread instance;
    
    private ProcessMonitorThread(HashMap serverTable, int sleepTime) {
        this.serverTable = serverTable;
        this.sleepTime = sleepTime;
    }
    
    @Override
    public void run() {
        while (true) {
            try {
                Thread.sleep((long)this.sleepTime);
            }
            catch (InterruptedException ex) {
                break;
            }
            Iterator<Object> iterator;
            synchronized (this.serverTable) {
                iterator = this.serverTable.values().iterator();
            }
            try {
                this.checkServerHealth(iterator);
            }
            catch (ConcurrentModificationException ex2) {
                break;
            }
        }
    }
    
    private void checkServerHealth(Iterator iterator) {
        if (iterator == null) {
            return;
        }
        while (iterator.hasNext()) {
            ((ServerTableEntry)iterator.next()).checkProcessHealth();
        }
        return;
    }
    
    static void start(HashMap hashMap) {
        int int1 = 1000;
        String property = System.getProperties().getProperty("com.sun.CORBA.activation.ServerPollingTime");
        if (property != null) {
            try {
                int1 = Integer.parseInt(property);
            }
            catch (Exception ex) {}
        }
        (ProcessMonitorThread.instance = new ProcessMonitorThread(hashMap, int1)).setDaemon(true);
        ProcessMonitorThread.instance.start();
    }
    
    static void interruptThread() {
        ProcessMonitorThread.instance.interrupt();
    }
    
    static {
        ProcessMonitorThread.instance = null;
    }
}
